#!/usr/bin/perl
# FILE: "/export/home/ams/nexenta/libxen-perl/trunk/test.pl"
# LAST MODIFICATION: "1, 16 03 2009 12:05:31 -0700 (ams)"
# (C) 2009 by Alexander Stetsenko, <ams@yandex.ru>
# vim:set sts=0 ts=8 sw=8:
# $Id:$

use strict;

#use XmlRpc;
use LibXen::Xen;

my $xenserver = LibXen::Xen::Server->new('https://xenserver/', 1);
$xenserver->login('root', 'secret');
my $session_id = $xenserver->session_id;
print "SESSION_ID: $session_id\n";

# RPC OBJECTS: host, PIF, PBD, SR, VDI, VBD, VM, VIF, Network 
# RPC OBJECTS: pool, event, task



my $result = undef;
# 
# my $result = $xenserver->call('SR.get_all_records');
# 
$result = $xenserver->call('VM.get_all_records', []);
print "=" x 78, "\n";
my $host=undef;
foreach my $k (keys %$result) {
	$host = $k;
	my $rec = $result->{$k};
	print "VM: $rec->{name_label}\n";
	&LibXen::XmlRpc::enable_debug();
	if ($rec->{name_label} eq 'vm1') {
		#$xenserver->call('VM.hard_shutdown', [$k]);
		$xenserver->call('VM.start', [$k]);
		last;
	}
	&LibXen::XmlRpc::disable_debug();
# 
# 	foreach my $kk (keys %$rec) {
# 		print "\$host_rec{$k}{$kk}=*$rec->{$kk}*\n";
# 		if ($kk eq 'cpu_configuration') {
# 			my $cpu_rec = $rec->{$kk};
# 			foreach my $cpu_k (keys %$cpu_rec) {
# 				print "\$host_cpu_rec: $cpu_k: *$cpu_rec->{$cpu_k}*\n";
# 			}
# 		}
# 	}
# 
	print "-" x 30, "\n";
}
print "=" x 78, "\n";

# 
# 
# &LibXen::XmlRpc::enable_debug();
# $result = $xenserver->call('host.get_all_records', []);
# &LibXen::XmlRpc::disable_debug();
# print "=" x 78, "\n";
# my $host=undef;
# foreach my $k (keys %$result) {
# 	$host = $k;
# 	my $rec = $result->{$k};
# 	print "host: $k\n";
# 	foreach my $kk (keys %$rec) {
# 		print "\$host_rec{$k}{$kk}=*$rec->{$kk}*\n";
# 		if ($kk eq 'cpu_configuration') {
# 			my $cpu_rec = $rec->{$kk};
# 			foreach my $cpu_k (keys %$cpu_rec) {
# 				print "\$host_cpu_rec: $cpu_k: *$cpu_rec->{$cpu_k}*\n";
# 			}
# 		}
# 	}
# 	print "-" x 30, "\n";
# }
# print "=" x 78, "\n";
# 
# # 
# # $result = $xenserver->call('host.get_cpu_configuration', [$host]);
# # print "=" x 78, "\n";
# # foreach my $k (keys %$result) {
# # 	my $rec = $result->{$k};
# # 	print "cpu_conf: $k\n";
# # 	foreach my $kk (keys %$rec) {
# # 		print "\$cpu_conf_rec{$k}{$kk}=*$rec->{$kk}*\n";
# # 	}
# # 	print "-" x 30, "\n";
# # }
# # print "=" x 78, "\n";
# # 
# 
# print "HOST: $host\n";
# my $cpus = $xenserver->call('host.get_host_CPUs', [$host]);
# print "=" x 78, "\n";
# foreach my $cpu (@$cpus) {
# 	print "cpu: $cpu\n";
# 	print "-" x 30, "\n";
# }
# print "=" x 78, "\n";
# 
# foreach my $cpu (@$cpus) {
# 	my $cpu_rec = $xenserver->call('host_cpu.get_record', [$cpu]);
# 	print "=" x 78, "\n";
# 	foreach my $k (keys %$cpu_rec) {
# 		print "cpu_rec: $k: $cpu_rec->{$k}\n";
# 		print "-" x 30, "\n";
# 	}
# 	print "=" x 78, "\n";
# }
# 


$xenserver->logout();
